DeclareModule CkServerSentEvent
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Declare ckInitGlobal()
CompilerEndIf
  Declare.i ckCreate()
  Declare ckDispose(obj.i)
  Declare.s ckData(obj.i)
  Declare.s ckDebugLogFilePath(obj.i)
  Declare setCkDebugLogFilePath(obj.i, value.s)
  Declare.s ckEventName(obj.i)
  Declare.s ckLastErrorHtml(obj.i)
  Declare.s ckLastErrorText(obj.i)
  Declare.s ckLastErrorXml(obj.i)
  Declare.s ckLastEventId(obj.i)
  Declare.l ckLastMethodSuccess(obj.i)
  Declare setCkLastMethodSuccess(obj.i, value.l)
  Declare.l ckRetry(obj.i)
  Declare.l ckVerboseLogging(obj.i)
  Declare setCkVerboseLogging(obj.i, value.l)
  Declare.s ckVersion(obj.i)
  Declare.l ckLoadEvent(obj.i, eventText.s)
EndDeclareModule

Module CkServerSentEvent
  PrototypeC.i cksPropGet(obj.i)
  PrototypeC.l cklPropGet(obj.i)
  PrototypeC.q ckqPropGet(obj.i)
  PrototypeC cksPropSet(obj.i, value.s)
  PrototypeC cklPropSet(obj.i, value.l)
  PrototypeC ckqPropSet(obj.i, value.q)
  PrototypeC.l cklMs(obj.i, arg1.s)
  PrototypeC.i CkServerSentEventCreate()
  PrototypeC CkServerSentEventDispose(obj.i)

CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   Procedure ckInitGlobal()
CompilerEndIf

  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "chilkatPb32.dll")
      CompilerElse
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "chilkatPb.dll")
      CompilerEndIf
    CompilerCase #PB_OS_MacOS
      CompilerIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPbM1.dylib")
      CompilerElse
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPb.dylib")
      CompilerEndIf
    CompilerCase #PB_OS_Linux
      ; Note: The full path of the .so shared library will be required when running from a compiled executable on Linux.
      ; See https://www.purebasic.fr/english/viewtopic.php?t=79882
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPb32.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm32
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm32.so")
      CompilerElseIf #PB_Compiler_Processor = #PB_Processor_arm64
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPbArm64.so")
      CompilerElse
        CkServerSentEventLibId.i = OpenLibrary(#PB_Any, "libchilkatPb.so")
      CompilerEndIf
  CompilerEndSelect
  Global ServerSentEventCreate.CkServerSentEventCreate = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_CreateW")
  Global ServerSentEventDispose.CkServerSentEventDispose = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_DisposeW")
  Global ServerSentEventData.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_dataW")
  Global ServerSentEventDebugLogFilePath.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_debugLogFilePathW")
  Global ServerSentEventPSetDebugLogFilePath.cksPropSet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_putDebugLogFilePathW")
  Global ServerSentEventEventName.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_eventNameW")
  Global ServerSentEventLastErrorHtml.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_lastErrorHtmlW")
  Global ServerSentEventLastErrorText.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_lastErrorTextW")
  Global ServerSentEventLastErrorXml.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_lastErrorXmlW")
  Global ServerSentEventLastEventId.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_lastEventIdW")
  Global ServerSentEventLastMethodSuccess.cklPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_getLastMethodSuccessW")
  Global ServerSentEventPSetLastMethodSuccess.cklPropSet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_putLastMethodSuccessW")
  Global ServerSentEventRetry.cklPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_getRetryW")
  Global ServerSentEventVerboseLogging.cklPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_getVerboseLoggingW")
  Global ServerSentEventPSetVerboseLogging.cklPropSet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_putVerboseLoggingW")
  Global ServerSentEventVersion.cksPropGet = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_versionW")
  Global ServerSentEventLoadEvent.cklMs = GetFunction(CkServerSentEventLibId,"CkServerSentEventU_LoadEventW")
CompilerIf #PB_Compiler_ExecutableFormat = #PB_Compiler_DLL
   EndProcedure
CompilerEndIf

  Procedure.i ckCreate() : ProcedureReturn ServerSentEventCreate() : EndProcedure
  Procedure ckDispose(obj.i) : ProcedureReturn ServerSentEventDispose(obj) : EndProcedure
  Procedure.s ckData(obj.i) : ProcedureReturn PeekS(ServerSentEventData(obj)) : EndProcedure
  Procedure.s ckDebugLogFilePath(obj.i) : ProcedureReturn PeekS(ServerSentEventDebugLogFilePath(obj)) : EndProcedure
  Procedure setCkDebugLogFilePath(obj.i, value.s) : ProcedureReturn ServerSentEventPSetDebugLogFilePath(obj,value) : EndProcedure
  Procedure.s ckEventName(obj.i) : ProcedureReturn PeekS(ServerSentEventEventName(obj)) : EndProcedure
  Procedure.s ckLastErrorHtml(obj.i) : ProcedureReturn PeekS(ServerSentEventLastErrorHtml(obj)) : EndProcedure
  Procedure.s ckLastErrorText(obj.i) : ProcedureReturn PeekS(ServerSentEventLastErrorText(obj)) : EndProcedure
  Procedure.s ckLastErrorXml(obj.i) : ProcedureReturn PeekS(ServerSentEventLastErrorXml(obj)) : EndProcedure
  Procedure.s ckLastEventId(obj.i) : ProcedureReturn PeekS(ServerSentEventLastEventId(obj)) : EndProcedure
  Procedure.l ckLastMethodSuccess(obj.i) : ProcedureReturn ServerSentEventLastMethodSuccess(obj) : EndProcedure
  Procedure setCkLastMethodSuccess(obj.i, value.l) : ProcedureReturn ServerSentEventPSetLastMethodSuccess(obj,value) : EndProcedure
  Procedure.l ckRetry(obj.i) : ProcedureReturn ServerSentEventRetry(obj) : EndProcedure
  Procedure.l ckVerboseLogging(obj.i) : ProcedureReturn ServerSentEventVerboseLogging(obj) : EndProcedure
  Procedure setCkVerboseLogging(obj.i, value.l) : ProcedureReturn ServerSentEventPSetVerboseLogging(obj,value) : EndProcedure
  Procedure.s ckVersion(obj.i) : ProcedureReturn PeekS(ServerSentEventVersion(obj)) : EndProcedure
  Procedure.l ckLoadEvent(obj.i, eventText.s) :  ProcedureReturn ServerSentEventLoadEvent(obj, eventText) :  EndProcedure
EndModule

